/* File:      flraggmin.P
**
** Author(s): Guizhen Yang 
**
** Contact:   flora-users@lists.sourceforge.net
**
** Copyright (C) The Research Foundation of SUNY, 1999-2001
**
** FLORA-2 is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** FLORA-2 is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with FLORA-2; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
** 
** $Id: flraggmin.P,v 1.8 2003/06/18 07:01:21 kifer Exp $
** 
*/


:- compiler_options([xpp_on]).

#include "flora_terms.flh"

:- import ground/1, member/2 from basics.



/*********************************************************************
  fllibmin(+Var,+VarList,+Goal,-Min)
*********************************************************************/
fllibmin(Var,[],Goal,Min) :-
	!,
	findall(Var,Goal,Matches),
	Matches=[H|L],
	flora_minaux(L,H,Min).

fllibmin(Var,VarList,Goal,Min) :-
	ground(VarList),
	!,
	findall(Var,Goal,Matches),
	Matches=[H|L],
	flora_minaux(L,H,Min).

fllibmin(Var,VarList,Goal,Min) :-
	!,
	findall(flora_result(Var,VarList),Goal,Matches),
	findall(Grp,member(flora_result(_,Grp),Matches),GL),
	sort(GL,Groups),
	member(VarList,Groups),
	findall(D,member(flora_result(D,VarList),Matches),DL),
	DL=[H|L],
	flora_minaux(L,H,Min).


/********************************************************************
  flora_minaux(+List,+CurrMin,-Min)
********************************************************************/
flora_minaux([],X,X) :- !.

flora_minaux([H|L],X,Min) :-
	!,
	( H @< X ->
	    flora_minaux(L,H,Min)
	;
	  flora_minaux(L,X,Min)
	).
