/* File:      flrimportedcalls.P - import statements that everyone needs
**
** Author(s): kifer
**
** Contact:   flora-users@lists.sourceforge.net
**
** Copyright (C) The Research Foundation of SUNY, 1999-2001
** 
** FLORA-2 is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** FLORA-2 is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with FLORA-2; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
**
*/

:- compiler_options([xpp_on]).

#include "flora_terms.flh"
#include "flora_porting.flh"


?- import FLORA_TNOT_PREDICATE/1 from flrnegation.
?- import FLLIBREFRESH/1, flora_abolish_table_call/1 from flrtables.
?- import FLLIBCATCH/3, FLLIBTHROW/1 from flrerrhandler.

%% These two are not strictly necessary, because flrutils.P and prolog2hilog
%% are loaded in the beginning
?- import flora_abort/0, flora_abort/1 from flrutils.
?- import P2H_PREDICATE/4 from prolog2hilog.

?- import
	flora_db_find_base/2,
	flora_db_insert_base/2,
	flora_db_delete_base/2,
	flora_db_insert_base_bt/2,
	flora_db_delete_base_bt/2
   from flrstoragebase.
